> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.nvidia.com/infra-controller/llms.txt.
> For full documentation content, see https://docs.nvidia.com/infra-controller/llms-full.txt.

# Create VPC Prefix

POST https://carbide-rest-api.carbide.svc.cluster.local/v2/org/{org}/carbide/vpc-prefix
Content-Type: application/json

Create a VPC Prefix for the org.

Org must have a Tenant entity. User must have `FORGE_TENANT_ADMIN` authorization role.

Reference: https://docs.nvidia.com/infra-controller/infra-controller/rest-api-reference/api-reference/vpc-prefix/create-vpc-prefix

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: NCX Infra Controller REST API
  version: 1.0.0
paths:
  /v2/org/{org}/carbide/vpc-prefix:
    post:
      operationId: create-vpc-prefix
      summary: Create VPC Prefix
      description: >-
        Create a VPC Prefix for the org.


        Org must have a Tenant entity. User must have `FORGE_TENANT_ADMIN`
        authorization role.
      tags:
        - subpackage_vpcPrefix
      parameters:
        - name: org
          in: path
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          description: >-
            ```

            export JWT_BEARER_TOKEN="<jwt-bearer-token>"


            # Example org name: "acme-inc

            export ORG_NAME=<org-name>


            # Use the JWT bearer token in your API request auth header:

            curl -v -X GET -H "Content-Type: application/json" -H
            "Authorization: Bearer $JWT_BEARER_TOKEN"
            https://carbide-rest-api.carbide.svc.cluster.local/v2/org/$ORG_NAME/carbide/user/current

            ```
          required: true
          schema:
            type: string
      responses:
        '201':
          description: Created
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/VpcPrefix'
        '400':
          description: Error response when request data cannot be validated
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CarbideAPIError'
        '403':
          description: >-
            Error response when user is not authorized to call an endpoint or
            retrieve/modify objects
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CarbideAPIError'
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/VpcPrefixCreateRequest'
servers:
  - url: https://carbide-rest-api.carbide.svc.cluster.local
components:
  schemas:
    VpcPrefixCreateRequest:
      type: object
      properties:
        name:
          type: string
          description: Human readable name for the VPC Prefix
        vpcId:
          type: string
          format: uuid
          description: ID of the VPC
        ipBlockId:
          type: string
          format: uuid
        prefixLength:
          type: integer
          description: >-
            Prefix length for the VPC Prefix. Valid range is 8 to 31, and max
            usable value depends on prefix length of parent IP Block.
      required:
        - name
        - vpcId
        - prefixLength
      description: Request data for creating VPC Prefix
      title: VpcPrefixCreateRequest
    VpcPrefixStatus:
      type: string
      enum:
        - Ready
        - Deleting
        - Error
      description: Status values for VPC Prefix objects
      title: VpcPrefixStatus
    StatusDetail:
      type: object
      properties:
        status:
          type: string
        message:
          type: string
        created:
          type: string
          format: date-time
        updated:
          type: string
          format: date-time
      description: Describes the details of a status transition for a resource
      title: StatusDetail
    VpcPrefix:
      type: object
      properties:
        id:
          type: string
          format: uuid
        name:
          type: string
          description: Name of the VPC Prefix
        siteId:
          type: string
          format: uuid
          description: ID of the Site the VPC Prefix belongs to
        vpcId:
          type: string
          format: uuid
          description: ID of the VPC the VPC Prefix belongs to
        tenantId:
          type: string
          format: uuid
          description: ID of the Tenant the VPC Prefix belongs to
        ipBlockId:
          type:
            - string
            - 'null'
          format: uuid
          description: ID of the IP Block that contains the prefix of the VPC Prefix
        prefix:
          type:
            - string
            - 'null'
          description: The network prefix including prefix length in CIDR notation
        prefixLength:
          type: integer
          description: >-
            Length of the prefix. Valid range is 8 to 31, and max usable value
            depends on prefix length of parent IP Block.
        status:
          $ref: '#/components/schemas/VpcPrefixStatus'
          description: Status of the VPC Prefix
        statusHistory:
          type: array
          items:
            $ref: '#/components/schemas/StatusDetail'
          description: Details of 20 most recent status changes
        created:
          type: string
          format: date-time
          description: Date and time when the VPC Prefix was created
        updated:
          type: string
          format: date-time
          description: Date and time when the VPC Prefix was updated
      description: VPC Prefixes are network grouping constructs for baremetal machines.
      title: VpcPrefix
    CarbideApiErrorSource:
      type: string
      enum:
        - carbide
      description: Source of the error. Only 'carbide' is supported
      title: CarbideApiErrorSource
    CarbideApiErrorData:
      type: object
      properties: {}
      description: Additional data about the error
      title: CarbideApiErrorData
    CarbideAPIError:
      type: object
      properties:
        source:
          $ref: '#/components/schemas/CarbideApiErrorSource'
          description: Source of the error. Only 'carbide' is supported
        message:
          type: string
          description: Message describing the error
        data:
          oneOf:
            - $ref: '#/components/schemas/CarbideApiErrorData'
            - type: 'null'
          description: Additional data about the error
      description: Describes the error response from NCX Infra Controller REST API
      title: CarbideAPIError
  securitySchemes:
    JWTBearerToken:
      type: http
      scheme: bearer
      description: >-
        ```

        export JWT_BEARER_TOKEN="<jwt-bearer-token>"


        # Example org name: "acme-inc

        export ORG_NAME=<org-name>


        # Use the JWT bearer token in your API request auth header:

        curl -v -X GET -H "Content-Type: application/json" -H "Authorization:
        Bearer $JWT_BEARER_TOKEN"
        https://carbide-rest-api.carbide.svc.cluster.local/v2/org/$ORG_NAME/carbide/user/current

        ```

```

## SDK Code Examples

```python
import requests

url = "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/vpc-prefix"

payload = {
    "name": "east-vpc-traffic-net",
    "vpcId": "5e28ad7c-5fb7-46d6-a28a-fc0ba6fdc4a3",
    "prefixLength": 20,
    "ipBlockId": "8c1d1a06-90a2-4863-8ee1-6029265b9f0a"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/vpc-prefix';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"name":"east-vpc-traffic-net","vpcId":"5e28ad7c-5fb7-46d6-a28a-fc0ba6fdc4a3","prefixLength":20,"ipBlockId":"8c1d1a06-90a2-4863-8ee1-6029265b9f0a"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/vpc-prefix"

	payload := strings.NewReader("{\n  \"name\": \"east-vpc-traffic-net\",\n  \"vpcId\": \"5e28ad7c-5fb7-46d6-a28a-fc0ba6fdc4a3\",\n  \"prefixLength\": 20,\n  \"ipBlockId\": \"8c1d1a06-90a2-4863-8ee1-6029265b9f0a\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/vpc-prefix")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"name\": \"east-vpc-traffic-net\",\n  \"vpcId\": \"5e28ad7c-5fb7-46d6-a28a-fc0ba6fdc4a3\",\n  \"prefixLength\": 20,\n  \"ipBlockId\": \"8c1d1a06-90a2-4863-8ee1-6029265b9f0a\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/vpc-prefix")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"name\": \"east-vpc-traffic-net\",\n  \"vpcId\": \"5e28ad7c-5fb7-46d6-a28a-fc0ba6fdc4a3\",\n  \"prefixLength\": 20,\n  \"ipBlockId\": \"8c1d1a06-90a2-4863-8ee1-6029265b9f0a\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/vpc-prefix', [
  'body' => '{
  "name": "east-vpc-traffic-net",
  "vpcId": "5e28ad7c-5fb7-46d6-a28a-fc0ba6fdc4a3",
  "prefixLength": 20,
  "ipBlockId": "8c1d1a06-90a2-4863-8ee1-6029265b9f0a"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/vpc-prefix");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"name\": \"east-vpc-traffic-net\",\n  \"vpcId\": \"5e28ad7c-5fb7-46d6-a28a-fc0ba6fdc4a3\",\n  \"prefixLength\": 20,\n  \"ipBlockId\": \"8c1d1a06-90a2-4863-8ee1-6029265b9f0a\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "name": "east-vpc-traffic-net",
  "vpcId": "5e28ad7c-5fb7-46d6-a28a-fc0ba6fdc4a3",
  "prefixLength": 20,
  "ipBlockId": "8c1d1a06-90a2-4863-8ee1-6029265b9f0a"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/vpc-prefix")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```